import { PublicKey, RpcInterface } from '@metaplex-foundation/umi';
import { GetAssetProofRpcResponse, GetAssetsByGroupRpcInput, GetAssetsByOwnerRpcInput, ReadApiAsset, ReadApiAssetList } from './readApiTypes';
export interface ReadApiInterface {
    getAsset(assetId: PublicKey): Promise<ReadApiAsset>;
    getAssetProof(assetId: PublicKey): Promise<GetAssetProofRpcResponse>;
    getAssetsByGroup(input: GetAssetsByGroupRpcInput): Promise<ReadApiAssetList>;
    getAssetsByOwner(input: GetAssetsByOwnerRpcInput): Promise<ReadApiAssetList>;
}
export declare const createReadApiDecorator: (rpc: RpcInterface) => RpcInterface & ReadApiInterface;
